#include "stdafx.h"

#ifndef WINDOWS_H
#define WINDOWS_H
#include <windows.h>
#endif

#ifndef STDIO_H
#define STDIO_H
#include <stdio.h>
#endif

#ifndef MCON2_H
#define MCON2_H
#include "mcon2.h"
#endif

const bool OCON_IsShowCon = true;

HANDLE OCON::hCON = NULL;
char OCON::sCON[2048];
int OCON::NCONS = 0;

void OCON::INIT(void)
{  
  if (OCON_IsShowCon && (NCONS++) == 0)
  { 
    AllocConsole();
    hCON=CreateConsoleScreenBuffer(GENERIC_WRITE,FILE_SHARE_WRITE,NULL,CONSOLE_TEXTMODE_BUFFER,NULL);
    COORD c;
    c.X = 80;
    c.Y = 1024;
    SetConsoleScreenBufferSize(hCON, c);
    SetConsoleActiveScreenBuffer(hCON);
  };
};

OCON::OCON(const char *tit)
{ 
  (*this).INIT();
  SetConsoleTitle(tit);
};

OCON::OCON()
{
  (*this).INIT();
};

OCON::~OCON()
{  
  if (OCON_IsShowCon && (--NCONS)==0)
  { 
    CloseHandle(hCON);
    hCON=NULL;
    FreeConsole();
  };
};

OCON& OCON::operator<<(const char &ch)
{  sprintf(sCON,"%c",ch);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const signed char &ch)
{  sprintf(sCON,"%c",ch);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const unsigned char &ch)
{  sprintf(sCON,"%c",ch);
   OUT_CON();
   return *this;
};


OCON& OCON::operator<<(const short int &i)
{  sprintf(sCON,"%hd",i);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const unsigned short int &i)
{  sprintf(sCON,"%hu",i);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const int &i)
{  sprintf(sCON,"%d",i);
   OUT_CON();
   return *this;
};
OCON& OCON::operator<<(const unsigned int &i)
{  sprintf(sCON,"%u",i);
   OUT_CON();
   return *this;
};


OCON& OCON::operator<<(const char *s)
{  sprintf(sCON,s);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const double &d)
{  sprintf(sCON,"%f",d);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const void * p)
{  sprintf(sCON,"%X",(DWORD)p);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const DWORD &dd)
{  sprintf(sCON,"%u",dd);
   OUT_CON();
   return *this;
};

OCON& OCON::operator<<(const bool &b)
{  sprintf(sCON,"%hX",b);
   OUT_CON();
   return *this;
};


void OCON::OUT_CON(void)
{  
   if (!OCON_IsShowCon) return;

   unsigned long iCON;
   int slen=lstrlen(sCON);
   CharToOemBuff(sCON,sCON,slen);
   WriteConsole(hCON,sCON,slen,&iCON,NULL);
};

