// OSerialPort.cpp: implementation of the OSerialPort class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OSerialPort.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const BOOL EmulMyDevice = FALSE;

#include <math.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OSerialPort::OSerialPort()
{
  m_hFile = INVALID_HANDLE_VALUE;  
  m_ByteCount = 0;
};

OSerialPort::~OSerialPort()
{
  ClosePort();
};

bool OSerialPort::OpenPort(int nPort)
{
  ClosePort();
  
  m_ByteCount = 0;
  CString s;
  s.Format("COM%d:", nPort);
  m_hFile = CreateFile(s, GENERIC_WRITE | GENERIC_READ, 0, NULL, OPEN_EXISTING, /*FILE_FLAG_OVERLAPPED*/0, NULL);
  if (m_hFile==INVALID_HANDLE_VALUE) 
  {
    ErrStr = "    ";
    return false;
  };

  ZeroMemory(&m_dcb, sizeof(m_dcb));

  m_dcb.DCBlength = sizeof(m_dcb);

  m_dcb.BaudRate = 115200/2; ///2; 
  m_dcb.BaudRate = 4800; 

  //m_dcb.BaudRate = 128000;    
  //if (EmulMyDevice) m_dcb.BaudRate = 115200;   IDOK
  m_dcb.fBinary = TRUE;
  m_dcb.fParity = FALSE;
  m_dcb.fDtrControl = DTR_CONTROL_DISABLE;
  m_dcb.fDsrSensitivity = FALSE;
 
  m_dcb.fRtsControl = RTS_CONTROL_ENABLE;
  m_dcb.StopBits = ONESTOPBIT;
  m_dcb.XonLim = 0; //0x800;
  m_dcb.XoffLim = 0; //0x200;
  m_dcb.ByteSize = 8;
  m_dcb.XonChar = 0x11;
  m_dcb.XoffChar = 0x13;
 
  if (!SetCommState(m_hFile, &m_dcb)) 
  {
    ErrStr = "       !";
    ClosePort();
    return false;
  };
  
  COMMTIMEOUTS to;
  GetCommTimeouts(m_hFile, &to);
  to.ReadIntervalTimeout = 0xffffffff;
  to.ReadTotalTimeoutMultiplier = 0;
  to.ReadTotalTimeoutConstant = 0;
  to.WriteTotalTimeoutMultiplier = 1000;
  to.WriteTotalTimeoutConstant = 1500;
  if (!SetCommTimeouts(m_hFile, &to))
  {
    ErrStr = "   -   ";
    ClosePort();
    return false;
  };

  DWORD M;
  GetCommMask(m_hFile, &M);
  M = 0;
  SetCommMask(m_hFile, M);

  m_IsOV = 0;

  BYTE B = 0xff;

  return true;  
  
  do
  {
  
    static int Adr = 0-1;
    Adr++;

    if (10)
    {
      Con<<"adr = "<<(void *)Adr<<"   ";
      BYTE BT[4]; ZeroMemory(BT, sizeof(BT));
      BT[0] = 0xcd;
      BT[1] = 0xe6;
      BT[2] = Adr;
      BT[3] = Adr>>8;
      DWORD szwr;
      WriteFile(m_hFile, &BT, sizeof(BT), &szwr, NULL);
      if (szwr!=sizeof(BT)) Con<<"szwr = "<<szwr<<"\n"; 
    };
    
    if (0)
    {
      BYTE BT[6]; ZeroMemory(BT, sizeof(BT));
      BT[0] = 0xcd;
      BT[1] = 0xe7;
      BT[2] = 7;
      BT[3] = 0;
      BT[4] = 0x33; //0x77; //Adr+0x80;
      BT[5] = 0x44; //Adr; //0x22; //Adr>>8;
      DWORD szwr;
      WriteFile(m_hFile, &BT, sizeof(BT), &szwr, NULL);
      if (szwr!=sizeof(BT)) Con<<"szwr = "<<szwr<<"\n"; 
      Sleep(-1);
    };

    if (0)
    {
      BYTE BT[3]; ZeroMemory(BT, sizeof(BT));
      BT[0] = 0xcd;
      BT[1] = 0xe8;
      BT[2] = 12;
      DWORD szwr;
      WriteFile(m_hFile, &BT, sizeof(BT), &szwr, NULL);
      if (szwr!=sizeof(BT)) Con<<"szwr = "<<szwr<<"\n"; 
    };
    
    if (0)
    {
      BYTE BT[4]; ZeroMemory(BT, sizeof(BT));
      BT[0] = 0xcd;
      BT[1] = 0xe9;
      BT[2] = 12;
      BT[3] = 0x55;
      DWORD szwr;
      WriteFile(m_hFile, &BT, sizeof(BT), &szwr, NULL);
      if (szwr!=sizeof(BT)) Con<<"szwr = "<<szwr<<"\n"; 
    };

    //M = 0;
    //SetCommMask(m_hFile, M);

    //SetCommMask(m_hFile, 0);


    BYTE RB[512];
    DWORD szrd = 0;
    ReadFile(m_hFile, &RB, sizeof(RB), &szrd, NULL);
    if (szrd!=0) Con<<"In !!!!!! szrd = "<<szrd<<"  B="<<(void *)(RB[0])<<", "<<(void *)(RB[1])<<"\n";
    
    //Sleep(10);
  } while (true);

		return true;
};

void OSerialPort::ClosePort()
{
  if (m_hFile == INVALID_HANDLE_VALUE) return;
  if (m_IsOV) 
		{
		  CancelIo(m_hFile); 
				m_IsOV = false;
		};
		CloseHandle(m_hFile);
  m_hFile = INVALID_HANDLE_VALUE;
};

void OSerialPort::SetRTS(bool On)
{
  //if (m_hFile == INVALID_HANDLE_VALUE) return;
  //m_dcb.fRtsControl = On ? RTS_CONTROL_ENABLE : RTS_CONTROL_DISABLE;
  //if (!SetCommState(m_hFile, &m_dcb)) AfxMessageBox("set status - 3!");
};

bool OSerialPort::IsOpened() const
{
  return m_hFile != INVALID_HANDLE_VALUE;  
};

bool OSerialPort::ReadData(BYTE *Buf, int BufSz, int &ReadedSz)
{
  if (m_hFile == INVALID_HANDLE_VALUE) return false;
  BOOL Is = ReadFile(m_hFile, Buf, BufSz, (DWORD *) &ReadedSz, NULL);
  if (Is) m_ByteCount += ReadedSz;
  return !!Is;
};

void OSerialPort::WriteData(const BYTE *Buf, int SzBuf)
{
  if (m_hFile == INVALID_HANDLE_VALUE) return;
  //Con<<"WR Sz="<<SzBuf<<"\n";
  DWORD SzWr;
  WriteFile(m_hFile, Buf, SzBuf, &SzWr, NULL);
};

void OSerialPort::WaitData(BYTE *Buf, int BufSz, int &ReadedSz, int TimeOut)
{
  //if (ReadedSz>=BufSz) return;    
  ReadedSz = 0;
  do
  {
    int rd = 0;
    ReadData(Buf+ReadedSz, BufSz - ReadedSz, rd);
    ReadedSz += rd;
    if (ReadedSz>=BufSz) break;
    if (TimeOut<=0) break;
    Sleep(1);     
    TimeOut-=1;
  } while (true);
};


int OSerialPort::GetByteCount() const
{
  return m_ByteCount;
};
