// TDA7313Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "NikyComProgPic16F873A.h"
#include "TDA7313Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTDA7313Dlg dialog


CTDA7313Dlg::CTDA7313Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTDA7313Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTDA7313Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTDA7313Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTDA7313Dlg)
	DDX_Control(pDX, IDC_CHECK_LOUDNESS, m_Loudness);
	DDX_Control(pDX, IDC_SLIDER_RR, m_RR);
	DDX_Control(pDX, IDC_SLIDER_RF, m_RF);
	DDX_Control(pDX, IDC_SLIDER_LR, m_LR);
	DDX_Control(pDX, IDC_SLIDER_LF, m_LF);
	DDX_Control(pDX, IDC_SLIDER_US, m_Us);
	DDX_Control(pDX, IDC_SLIDER_TREBLE, m_Treble);
	DDX_Control(pDX, IDC_SLIDER_IN, m_In);
	DDX_Control(pDX, IDC_SLIDER_BASS, m_Bass);
	DDX_Control(pDX, IDC_SLIDER_LEVEL, m_Level);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTDA7313Dlg, CDialog)
	//{{AFX_MSG_MAP(CTDA7313Dlg)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CHECK_LOUDNESS, OnCheckLoudness)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTDA7313Dlg message handlers

void CTDA7313Dlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CTDA7313Dlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CTDA7313Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
 m_Level.SetRange(0, 63);
 m_Level.SetPos(0);

 m_In.SetRange(0, 3);
 m_In.SetPos(0);

 m_Loudness.SetCheck(BST_CHECKED);

 m_Us.SetRange(0, 3);
 m_Us.SetPos(0);

 m_Bass.SetRange(0, 14);
 m_Bass.SetPos(7);
 m_Bass.UpdateWindow();

 m_Treble.SetRange(0, 14);
 m_Treble.SetPos(7);
 m_Treble.UpdateWindow();

 m_LF.SetRange(0, 31);
 m_LF.SetPos(31);

 m_RF.SetRange(0, 31);
 m_RF.SetPos(0*31);

 m_LR.SetRange(0, 31);
 m_LR.SetPos(31);

 m_RR.SetRange(0, 31);
 m_RR.SetPos(31);

	return TRUE;  
};

void CTDA7313Dlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	
 CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
 if (nSBCode == SB_THUMBTRACK)
 {
    // Con<<"Pos = "<<nPos<<"\n";
    //SetTDA_All();
 };
 //Con<<"nSBCode = "<<nSBCode<<"\n";
 SetTDA_All();
};

void CTDA7313Dlg::SetTDA_All()
{
  BYTE B;
  
  
  
  B = ((31 - m_LF.GetPos()) & 31) + (4<<5);
  //Con<<"B_LF = "<<(void *)B<<"\n";
  //if (B != 0x88) 
  m_pPort->WriteData(&B, sizeof(B));
  Sleep(1);        

  B = ((31 - m_RF.GetPos()) & 31) + (5<<5);
  //Con<<"B_RF = "<<(void *)B<<"\n";
  m_pPort->WriteData(&B, sizeof(B));
  Sleep(1);         
  
  B = 63 - m_Level.GetPos();
  //Con<<"B_LEVEL = "<<(void *)B<<"\n";  
  m_pPort->WriteData(&B, sizeof(B));
  Sleep(1);  
  

  B = 31 - m_LR.GetPos() + (6<<5);
  m_pPort->WriteData(&B, sizeof(B));
  Sleep(1);
  
  
  B = 31 - m_RR.GetPos() + (7<<5);
  m_pPort->WriteData(&B, sizeof(B)); 
  Sleep(1);
  
 
  B = 0x40 + m_In.GetPos() + ((m_Us.GetPos() ^ 3) << 3) + (m_Loudness.GetCheck() ? 0 : 4);
  m_pPort->WriteData(&B, sizeof(B));
  Sleep(1);

  int bass = m_Bass.GetPos() - 7;
  B = 0x60 + (7 - abs(bass)) + (bass>0 ? 8 : 0);
  m_pPort->WriteData(&B, sizeof(B));
  Sleep(1);
  
  int treble = m_Treble.GetPos() - 7;
  B = 0x70 + (7 - abs(treble)) + (treble>0 ? 8 : 0);
  m_pPort->WriteData(&B, sizeof(B));
  Sleep(1);  


};

void CTDA7313Dlg::OnCheckLoudness() 
{
  SetTDA_All();
};
